<?php

/*
 * Use this script to test your IMAP connection.
 * This script will display the number of messages 
 * in the inbox, then display the subject line and
 * body for each message (with line breaks converted 
 * to <br /> for better display).  Then the script 
 * will DELETE all messages in the inbox and disconnect, 
 * so it is STRONGLY recommended that you not use this 
 * on any email accounts you actually use!
 *
 * --Kris
 * 08.06.2008
 */

$mailbox = imap_open( "{kriscraig.com:143}INBOX", "everlist", "555555" );

print "# of messages: ";

$nummsg = imap_num_msg( $mailbox );

print $nummsg;

print "<hr width=\"100%\" />";

for ( $mloop = 1; $mloop <= $nummsg; $mloop++ )
{
	$msgheader = imap_headerinfo( $mailbox, $mloop );
	
	print "From: ";
	
	print $msgheader->senderaddress;
	
	print "<br /><br />";
	
	print "Reply-To: ";
	
	print $msgheader->reply_toaddress;
	
	print "<br /><br />";
	
	print "From (other method): ";
	
	foreach ( $msgheader->from as $fromkey => $fromobj )
	{
		$frombox = $fromobj->mailbox;
		$fromhost = $fromobj->host;
	}
	
	print $frombox . "@" . $fromhost;
	
	print "<br /><br />";
	
	print "To: ";
	
	print $msgheader->toaddress;
	
	print "<br /><br />";
	
	print "Subject: ";
	
	print $msgheader->subject;
	
	print "<br /><br />Body:<br />";
	
	$msgbody = imap_body( $mailbox, $mloop );
	
	$msgbody = str_replace( "\n", "<br />", $msgbody );
	
	print $msgbody;
	
	print "<hr width=\"100%\" />";
	
	imap_delete( $mailbox, $mloop );
}

imap_expunge( $mailbox );

imap_close( $mailbox );
