<?php

/*
 * EverList - A free email listserv written in PHP.
 * Copyright (C) 2008 by Kris Craig.
 * 07.20.2008
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

require( "config.php" );
require( "common.php" );

foreach ( $_GET as $getvar => $getval )
{
	$$getvar = $getval;
}

$userdata = array();
$userdata = AuthenticateUser();

$topicdata = array();
$topicdata = LoadTopic( $tid );

if ( $topicdata["success"] == FALSE )
{
	GenerateHeader( "EverList - Topic", TRUE );
	$topdata = array();
	$topdata = GenerateTop( $userdata );
	
	print "ERROR!  " . $topicdata["errmsg"];
	
	GenerateFooter();
	die();
}

$fid = $topicdata["fid"];

$forumdata = array();
$forumdata = LoadForum( $fid );

$isadmin = CheckUserAdmin();

if ( $forumdata["isclosed"] == 1 
	|| ( $forumdata["isclosed"] == 3 && $isadmin == FALSE ) )
{
	print "<b style=\"color: red\">";
	print "This forum is currently CLOSED.  Please contact the listserv administrator for further information.";
	print "</b>";
	
	GenerateBottom();
	GenerateFooter();
	die();
}

if ( trim( $fid ) == NULL || $forumdata["success"] == FALSE )
{
	header( "Location: all_forums.php" );
	die();
}

$profiledata = array();
$profiledata = LoadProfile( $userdata["userid"] );

$ok = EnterForum( $fid, $userdata, $forumdata, $profiledata );

/* Alrighty, everything's authenticated!  Now let's display the posts.  --Kris */
GenerateHeader( "EverList - " . $topicdata["tname"], TRUE, TRUE );
$topdata = array();
$topdata = GenerateTop( $userdata );

$postsdata = array();
$postsdata = LoadPosts( $tid );

if ( $postsdata["success"] == FALSE )
{
	print "ERROR!  " . $postsdata["errmsg"];
	GenerateFooter();
	die();
}

for ( $ploop = 1; $ploop <= $postsdata[0]; $ploop++ )
{
	?>
	<a name="<?php print $postsdata[$ploop]["pid"]; ?>"></a>
	
	<?php
	if ( $ploop == 1 )
	{
		$retext = NULL;
	}
	else
	{
		$retext = "RE: ";
	}
	
	if ( $ploop == $postsdata[0] )
	{
		$headerbg = "#227722";
		$tcorner = "a";
		
		if ( $newpost == 1 )
		{
			print "<h3 style=\"color: blue\">Your new post has been added successfully!</h3>";
			print "<b style=\"color: red\">You have about 15 minutes to edit/delete your post before it gets emailed-out.</b><br /><br />";
		}
		else if ( $editpost == 1 )
		{
			print "<h3 style=\"color: blue\">Your post has been edited successfully!</h3>";
			print "<b style=\"color: red\">You have about 15 minutes to edit/delete your post before it gets emailed-out.</b><br /><br />";
		}
	}
	else
	{
		$headerbg = "#449944";
		$tcorner = "b";
	}
	
	if ( $ploop % 2 == 1 )
	{
		$postbg = "#C0F3C0";
		$bcorner = "a";
	}
	else
	{
		//$postbg = "#90EE90";
		//$bcorner = "b";
		$postbg = "#C0F3C0";
		$bcorner = "a";
	}
	
	$pudata = array();
	$pudata = LoadUser( $postsdata[$ploop]["createdbyuserid"] );
	
	$ppdata = array();
	$ppdata = LoadProfile( $postsdata[$ploop]["createdbyuserid"] );
	
	if ( $userdata["userid"] == $postsdata[$ploop]["createdbyuserid"] 
		&& strcasecmp( $postsdata[$ploop]["pstatus"], "NEW" ) == 0 )
	{
		$edittext = "[<a class=\"columnheader2\" href=\"deletepost.php?pid=" . $postsdata[$ploop]["pid"] . "\">Delete</a> | ";
		$edittext .= "<a class=\"columnheader2\" href=\"editpost.php?pid=" . $postsdata[$ploop]["pid"] . "\">Edit</a>] &nbsp;";
	}
	else
	{
		$edittext = NULL;
	}
	
	?>
	<table border="0" cellpadding="0" cellspacing="0" width="750">
	 <tr>
	
	  <td><img src="images/space1px.gif" width="15" height="1" alt="" /></td>
	  <td>
	   <table border="0" cellpadding="0" cellspacing="0" width="100%">
	    <tr>
	     <td width="8" bgcolor="<?php print $headerbg; ?>"><img src="images/topleft<?php print $tcorner; ?>.gif" width="8" height="23" alt="" /></td>
	     <td bgcolor="<?php print $headerbg; ?>" width="716">
	      <table border="0" cellpadding="0" cellspacing="0" width="100%">
	       <tr>
	        <td align="left" bgcolor="<?php print $headerbg; ?>"><b><font size="2" color="#FFFFFF"></font><font face="Verdana, Arial, Helvetica, sans-serif" color="#FFFFFF" size=1><?php print $edittext . $retext . $topicdata["tname"]; ?></font></b></td>
	
	        <td align="right" bgcolor="<?php print $headerbg; ?>"><b><font size="2" color="#FFFFFF">&nbsp;</b></font><font size=1 color="#FFFFFF"><?php print date( "M d, Y @ g:i A (T)", $postsdata[$ploop]["ptimestamp"] ); ?><img src="images/space1px.gif" width="5" height="1" alt="" />- Author: &nbsp;<a class="columnheader" href="viewprofile.php?userid=<?php print $pudata["userid"]; ?>"><?php print $ppdata["fullname"]; ?></a></font></td>
	       </tr>
	      </table>
	     </td>
	     <td width="11"><img src="images/topright<?php print $tcorner; ?>.gif" width="11" height="23" alt="" /></td>
	    </tr>
	   </table>
	
	   <table border="0" cellpadding="0" cellspacing="0" width="735">
	    <tr>
	     <td bgcolor="<?php print $postbg; ?>" colspan="4"><img src="images/space1px.gif" width="735" height="10" alt="" /></td>
	    </tr>
	    <tr>
	     <td bgcolor="<?php print $postbg; ?>"><img src="images/space1px.gif" width="8" height="1" alt="" /></td>
	     <td bgcolor="<?php print $postbg; ?>">
	
	    
	                <table cellspacing="0" cellpadding="5" border="0" width="701">
	                    
	    <tr>
	        <td valign="middle" align="left" colspan="2">
	        
	<?php
	
	if ( $searchstring != NULL )
	{
		$searchstring = urldecode( trim( $searchstring ) );
		
		/*$findtext = array();
		$findtext[1] = $searchstring;
		
		$replacetext = array();
		$replacetext[1] = "<span style=\"background-color: yellow\">$searchstring</span>";
		
		print str_ireplace( $findtext, $replacetext, $postsdata[$ploop]["ptext"] );*/
		print preg_replace( "/($searchstring)/i", "<span style=\"background-color: yellow\">$1</span>", $postsdata[$ploop]["ptext"] );
	}
	else
	{
		print $postsdata[$ploop]["ptext"];
	}
	
	?>
	
	</td>
	</tr>
	</table>
	
	     </td>

     <td bgcolor="<?php print $postbg; ?>" valign="TOP">
    
      <img src="images/space1px.gif" height=13 width=13></td>
        
     <td bgcolor="<?php print $postbg; ?>"><img src="images/space1px.gif" width="8" height="1" alt="" /></td>

    </tr>
   </table>

  </td>

 </tr>
 
 <tr>
  <td></td>
  <td>
   
   <table border="0" cellpadding="0" cellspacing="0" width="100%">
    <tr>
     <td width="8"><img src="images/botleft<?php print $bcorner; ?>.gif" width="8" height="8" alt="" /></td>
     <td bgcolor="<?php print $postbg; ?>"><img src="images/space1px.gif" width="1" height="8" alt="" /></td>
     <td width="11"><img src="images/botright<?php print $bcorner; ?>.gif" width="11" height="8" alt="" /></td>

    </tr>
   </table>

  </td>
 </tr>

</table>

    
            <br />

            <table cellspacing="0" cellpadding="5" border="0" width="750">
                <tr><td colspan=2 align="right"></td></tr>
            </table>
        
	
	<?php
}

if ( $forumdata["isclosed"] == 1 || $forumdata["isclosed"] == 2 
	|| ( $forumdata["isclosed"] == 3 && $isadmin == FALSE ) 
	|| ( $forumdata["isclosed"] == 4 && $isadmin == FALSE ) )
{
	print "<b style=\"color: red\">";
	print "This forum is currently CLOSED to new posts.  Please contact the listserv administrator for further information.";
	print "</b>";
	
	GenerateBottom();
	GenerateFooter();
	die();
}

$subscribed = IsSubscribed( $profiledata, $forumdata["fid"] );

if ( $userdata["authstatus"] != 1 )
{
	print "<b>You must be logged-in to post on this listserv.</b>";
	print "<br /><br />";
	print "<a href=\"login.php\">Login</a>";
}
else if ( $forumdata["ispublic"] != 1 && $subscribed == FALSE )
{
	print "<b>You must be subscribed to post on this forum.</b>";
	print "<br /><br />";
	if ( $forumdata["subscriptionpolicy"] == 0 )
	{
		print "Sorry, this forum is currently closed to new subscriptions.";
	}
	else if ( $forumdata["subscriptionpolicy"] == 3 )
	{
		print "You must be invited to this forum before you can subscribe to it.";
	}
	else
	{
		print "<a href=\"subscribe.php?fid=" . $forumdata["fid"] . "\">Click HERE to Subscribe!</a>";
	}
}
else
{
	/* Before we allow the post, check against the hourly/daily post limits.  --Kris */
	$limitreached = CheckPostLimitReached( $forumdata, $userdata );
	
	if ( $limitreached == 1 )
	{
		print "You have reached the maximum number of hourly posts allowed on this forum.  Please try again later.";
	}
	else if ( $limitreached == 2 )
	{
		print "You have reached the maximum number of daily posts allowed on this forum.  Please try again tomorrow.";
	}
	else
	{
		/* Whew!  Everything passed!  Allow the new post.  --Kris */
		NewPost( $tid );
	}
}

GenerateBottom();
GenerateFooter();
