<?php

/*
 * EverList - A free email listserv written in PHP.
 * Copyright (C) 2008 by Kris Craig.
 * 07.20.2008
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

require( "common.php" );

foreach ( $_GET as $getvar => $getval )
{
	$$getvar = $getval;
}

foreach ( $_POST as $postvar => $postval )
{
	$$postvar = $postval;
}

$userdata = array();
$userdata = AuthenticateUser();
if ( $userdata["authstatus"] != 1 )
{
	UserLogin( $userdata["authstatus"] );
	die();
}

GenerateHeader( "EverList - Search", TRUE );
$topdata = array();
$topdata = GenerateTop( $userdata );

$profiledata = array();
$profiledata = LoadProfile( $userdata["userid"] );

$forumdata = array();
$forumdata = LoadForum( $profiledata["currentforumid"] );

$subscribed = IsSubscribed( $profiledata, $forumdata["fid"] );

if ( $subscribed == FALSE )
{
	print "<h3>" . $forumdata["fname"] . "</h3>";
	print "<b style=\"color: red\">You cannot search this forum because you are not subscribed to it!</b>";
	print "<br />";
	
	if ( $forumdata["subscriptionpolicy"] == 0 )
	{
		print "Sorry, this forum is currently closed to new subscriptions.";
	}
	else if ( $forumdata["subscriptionpolicy"] == 3 )
	{
		print "You must be invited to this forum before you can subscribe to it.";
	}
	else
	{
		print "<a href=\"subscribe.php?fid=" . $forumdata["fid"] . "\">Click HERE to Subscribe!</a>";
	}
	
	GenerateBottom();
	GenerateFooter();
	die();
}

if ( $searchtitle != NULL || $formstage == NULL )
{
	$searchtitlechecked = " checked";
}
else
{
	$searchtitlechecked = NULL;
}

if ( $searchposts != NULL || $formstage == NULL )
{
	$searchpostschecked = " checked";
}
else
{
	$searchpostschecked = NULL;
}

?>
<form name="searchform" action="search.php" method="POST">

<input type="hidden" name="formstage" value="1" />

<table border="0" cellspacing="2" cellpadding="2">
<tr>
<td colspan="2">
<h3>Search: <b style="color: blue"><?php print $forumdata["fname"]; ?></b></h3>
</td>
</tr>
<tr>
<td align="right">
<b>Search for:</b> &nbsp;
</td>
<td>
<input type="text" name="searchstring" value="<?php print $searchstring; ?>" maxlength="255" size="50" />
</td>
</tr>
<tr>
<td colspan="2">
<span style="font-size: 4pt"><br /></span>
</td>
</tr>
<tr>
<td align="center" colspan="2">
<table border="0" cellspacing="0" cellpadding="0" width="75%">
<tr>
<td colspan="3" align="center" bgcolor="#AAFFAA">
<b>Look in....</b>
</td>
</tr>
<tr>
<td>
<input type="checkbox" name="searchtitle" value="1"<?php print $searchtitlechecked; ?> /> Subject
</td>
<td width="50%">
&nbsp;
</td>
<td>
<input type="checkbox" name="searchposts" value="1"<?php print $searchpostschecked; ?> /> Posts
</td>
</tr>
</table>
</td>
</tr>
<tr>
<td colspan="2" align="center">
<input type="submit" name="submitform" value="Search!" />
</td>
</tr>
</table>

<br />

<hr width="100%" />

<?php
if ( $formstage == 1 )
{
	if ( trim( $searchstring ) == NULL )
	{
		print "<b>If you search for nothing, you will find nothing.</b>";
	}
	else if ( $searchtitle == NULL && $searchposts == NULL )
	{
		print "<b>You must check subject and/or posts!</b>";
	}
	else
	{
		$searchstring = addslashes( $searchstring );
		
		$topicids = array();
		$topicids[0] = 0;
		
		$fid = $profiledata["currentforumid"];
		
		$highlighturl = NULL;
		
		if ( $searchtitle != NULL )
		{
			$query = "select tid from topics where fid='$fid' AND tname like('%" . $searchstring . "%')";
			$resulttl1 = mysql_query( $query ) or die( "Query '$query' failed for resulttl1 in search.php : " . mysql_error() );
			
			while ( $line = mysql_fetch_array( $resulttl1, MYSQL_ASSOC ) )
			{
				$topicids[0]++;
				foreach ( $line as $col_value )
				{
					$topicids[$topicids[0]] = $col_value;
				}
			}
		}
		
		$validtids = array();
		$validtids[0] = 0;
		
		$query = "select tid from topics where fid='$fid'";
		$resulttl5 = mysql_query( $query ) or die( "Query '$query' failed for resulttl5 in search.php : " . mysql_error() );
		
		while ( $line = mysql_fetch_array( $resulttl5, MYSQL_ASSOC ) )
		{
			$validtids[0]++;
			foreach ( $line as $col_value )
			{
				$validtids[$validtids[0]] = $col_value;
			}
		}
		
		if ( $searchposts != NULL && $validtids[0] > 0 )
		{
			$highlighturl = "&searchstring=" . urlencode( $searchstring );
			$query = "select tid from posts where ptext like('%" . $searchstring . "%')";
			$query .= " AND (";
			for ( $tidloop = 1; $tidloop <= $validtids[0]; $tidloop++ )
			{
				$query .= " tid='" . $validtids[$tidloop] . "'";
				if ( $tidloop < $validtids[0] )
				{
					$query .= " OR";
				}
			}
			$query .= " )";
			$resulttl2 = mysql_query( $query ) or die( "Query '$query' failed for resulttl2 in search.php : " . mysql_error() );
			
			while ( $line = mysql_fetch_array( $resulttl2, MYSQL_ASSOC ) )
			{
				$topicids[0]++;
				foreach ( $line as $col_value )
				{
					$topicids[$topicids[0]] = $col_value;
				}
			}
		}
		
		/* Filter out duplicate ID's with a recursive array loop.  --Kris */
		$tmpidarr = array();
		$tmpidarr[0] = 0;
		foreach ( $topicids as $tkey => $tval )
		{
			if ( $tkey == 0 )
			{
				continue;
			}
			
			$dupfound = FALSE;
			foreach ( $tmpidarr as $tkeyr => $tvalr )
			{
				if ( $tkeyr == 0 )
				{
					continue;
				}
				
				if ( $tvalr == $tval )
				{
					$dupfound = TRUE;
					break;
				}
			}
			
			if ( $dupfound == TRUE )
			{
				continue;
			}
			
			$tmpidarr[0]++;
			$tmpidarr[$tmpidarr[0]] = $tval;
		}
		$topicids = $tmpidarr;
		
		if ( $topicids[0] == 0 )
		{
			print "Your search did not match any results.";
		}
		else
		{
			if ( $topicids[0] == 1 )
			{
				$restext = "result";
			}
			else
			{
				$restext = "results";
			}
			
			print "<b>Found <span style=\"color: blue\">" . $topicids[0];
			print "</span> $restext for <span style=\"background-color: yellow\">";
			print stripslashes( $searchstring ) . "</span>:";
			print "<br /><br />";
			
			$query = "select * from topics where fid='" . $profiledata["currentforumid"] . "'";
			
			$query .= " AND (";
			for ( $tloop = 1; $tloop <= $topicids[0]; $tloop++ )
			{
				$query .= " tid='" . $topicids[$tloop] . "'";
				if ( $tloop < $topicids[0] )
				{
					$query .= " OR";
				}
			}
			$query .= " )";
			
			$query .= " order by ttimestamp DESC, tname ASC";
			$resulttl3 = mysql_query( $query ) or die( "Query 'query' failed for resulttl3 in search.php : " . mysql_error() );
			
			$topics = array();
			$topics[0] = 0;
			while ( $line = mysql_fetch_array( $resulttl3, MYSQL_ASSOC ) )
			{
				$topics[0]++;
				$topics[$topics[0]] = array();
				$sqloop = 0;
				foreach ( $line as $col_value )
				{
					$fieldname = mysql_field_name( $resulttl3, $sqloop );
					$topics[$topics[0]][$fieldname] = $col_value;
					$sqloop++;
				}
			}
			
			for ( $tloop = 1; $tloop <= $topics[0]; $tloop++ )
			{
				$query = "select tid from posts where tid='" . $topics[$tloop]["tid"] . "'";
				$resulttl4 = mysql_query( $query ) or die( "Query 'query' failed for resulttl4 in search.php : " . mysql_error() );
				
				$topics[$tloop]["replies"] = -1;
				while ( $line = mysql_fetch_array( $resulttl4, MYSQL_ASSOC ) )
				{
					$topics[$tloop]["replies"]++;
				}
			}
			
			?>
			<table border="0" cellpadding="0" cellspacing="0" bgcolor="#FFFFFF"><tr><td><img src="images/space1px.gif" height=1 width=15 alt="" /></td><td align=right>
			
			<table border=0 width=749 cellpadding=3 cellspacing=1>
			<tr>
			<td bgcolor="#449944" width="25%"><table width="100%" cellpadding=0 cellspacing=0 border=0><tr><td align=left><font color="#FFFFFF" style="text-decoration:none" face="Verdana, Arial, Helvetica, sans-serif" size="-2"><b><a class="columnheader" href="javascript: HelpWindow( 'mcolumnshelp.php#datetime' );">Last Post</a></b></font></td><td width="10%" align=right><table width=10 cellpadding=0 cellspacing=0 border=0><tr><td align=right></td></tr><tr><td align=right></td></tr></table></td></tr></table></td>
			<td bgcolor="#227722" width="50%"><table width="100%" cellpadding=0 cellspacing=0 border=0><tr><td align=left><font color="#FFFFFF" style="text-decoration:none" face="Verdana, Arial, Helvetica, sans-serif" size="-2"><b><a class="columnheader" href="javascript: HelpWindow( 'mcolumnshelp.php#subject' );">Subject</a></b></font></td><td width="10%" align=right><table width=10 cellpadding=0 cellspacing=0 border=0><tr><td align=right></td></tr><tr><td align=right></td></tr></table></td></tr></table></td>
			<td bgcolor="#449944" width="5%"><table width="100%" cellpadding=0 cellspacing=0 border=0><tr><td align=left><font color="#FFFFFF" style="text-decoration:none" face="Verdana, Arial, Helvetica, sans-serif" size="-2"><b><a class="columnheader" href="javascript: HelpWindow( 'mcolumnshelp.php#replies' );">Replies</a></b></font></td><td width="10%" align=right><table width=10 cellpadding=0 cellspacing=0 border=0><tr><td align=right></td></tr><tr><td align=right></td></tr></table></td></tr></table></td>
			<td bgcolor="#449944"><table width="100%" cellpadding=0 cellspacing=0 border=0><tr><td align=left><font color="#FFFFFF" style="text-decoration:none" face="Verdana, Arial, Helvetica, sans-serif" size="-2"><b><a class="columnheader" href="javascript: HelpWindow( 'mcolumnshelp.php#author' );">Author</a></b></font></td><td width="10%" align=right><table width=10 cellpadding=0 cellspacing=0 border=0><tr><td align=right></td></tr><tr><td align=right></td></tr></table></td></tr></table></td>
			</tr>
			
			<?php
			/* If we somehow end up with an empty topic (no posts), skip it.  --Kris */
			$tmparr = array();
			$tmparr[0] = 0;
			for ( $tloop = 1; $tloop <= $topics[0]; $tloop++ )
			{
				if ( $topics[$tloop]["replies"] < 0 )
				{
					continue;
				}
				
				$tmparr[0]++;
				$tmparr[$tmparr[0]] = array();
				$tmparr[$tmparr[0]] = $topics[$tloop];
			}
			$topics = $tmparr;
			
			$rowcol[1] = "#C0F3C0";
			$rowcol[0] = "#90EE90";
			for ( $tloop = 1; $tloop <= $topics[0]; $tloop++ )
			{
				$pdata = array();
				$pdata = LoadProfile( $topics[$tloop]["createdbyuserid"] );
				
				//$topics[$tloop]["tname"] = str_ireplace( $searchstring, "<span style=\"background-color: yellow\">$searchstring</span>", $topics[$tloop]["tname"] );  //Depreciated because it doesn't preserve case.  --Kris
				$topics[$tloop]["tname"] = preg_replace( "/($searchstring)/i", "<span style=\"background-color: yellow\">$1</span>", $topics[$tloop]["tname"] );
				
				?>
				<tr>
				<td bgcolor="<?php print $rowcol[$tloop % 2]; ?>" valign=top><font face="Verdana, Arial, Helvetica, sans-serif" size=-2><?php print date( "M d, Y @ g:i A (T)", $topics[$tloop]["ttimestamp"] ); ?></font></td>
				<td bgcolor="<?php print $rowcol[$tloop % 2]; ?>" valign=top><font face="Verdana, Arial, Helvetica, sans-serif" size=-2><b><a href="viewtopic.php?tid=<?php print $topics[$tloop]["tid"] . $highlighturl; ?>"><?php print $topics[$tloop]["tname"]; ?></a></b></font></td>
				<td bgcolor="<?php print $rowcol[$tloop % 2]; ?>" valign=top><font face="Verdana, Arial, Helvetica, sans-serif" size=-2><?php print $topics[$tloop]["replies"]; ?></font></td>
				<td bgcolor="<?php print $rowcol[$tloop % 2]; ?>" valign=top><font face="Verdana, Arial, Helvetica, sans-serif" size=-2><a class="darklink" href="viewprofile.php?userid=<?php print $pdata["userid"]; ?>"><?php print $pdata["fullname"]; ?></a></font></td>
				</tr>
				<?php
			}
		}
	}
}

GenerateBottom();
GenerateFooter();
